<?php

namespace Util;

use Zend\Mail as ZendMail;

class SmtpMail extends Mail
{
    private $smtpName;
    private $smtpHost;
    private $smtpConnectionClass;
    private $smtpUsername;
    private $smtpPassword;

    public function __construct($name, $host, $user, $password, $class) {
        $this->smtpName = $name;
        $this->smtpHost = $host;
        $this->smtpConnectionClass = $class;
        $this->smtpUsername = $user;
        $this->smtpPassword = $password;
    }

    private function createSmtpOptions() {
        $options = new ZendMail\Transport\SmtpOptions(array(
            'name' => $this->smtpName,
            'host' => $this->smtpHost,
            'connection_class' => $this->smtpConnectionClass,
            'connection_config' => array(
                'username' => $this->smtpUsername,
                'password' => $this->smtpPassword
            )
        ));
        return $options;
    }

    public function send() {
        $email = new ZendMail\Message();
        $email->addTo($this->getTo())
            ->addFrom($this->getFrom())
            ->setSubject($this->getSubject())
            ->setBody($this->getBody());
        $transport = new ZendMail\Transport\Smtp();
        $options = $this->createSmtpOptions();
        $transport->setOptions($options);
        $transport->send($email);
    }
}