IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CRIACARD_CICLO'  AND
	        TYPE = 'P'                        AND
	        U.UID = O.UID                     AND
	        U.NAME = USER
          )
  DROP PROCEDURE CRIACARD_CICLO 
GO

CREATE PROCEDURE CRIACARD_CICLO (
   @P_CDFILIAL      VARCHAR(4),
   @P_CDSERVFILI    VARCHAR(5),
   @P_DTMESCARD     DATETIME,
   @P_CDOPERADOR    VARCHAR(12),
   @P_IDEXCLUIRCARD VARCHAR(1),
   @P_NRLOGCARDCICLO VARCHAR(10),
   @P_CDPADCICLO     VARCHAR(5))
AS

DECLARE   @V_NRCARDAPIO VARCHAR(20);
DECLARE   @V_NRCARDAGRE VARCHAR(20);
DECLARE   @V_CARDESPEC  VARCHAR(1);
DECLARE   @V_CDGRUPOPER VARCHAR(2);
DECLARE   @V_DTMESCARDAPIO DATETIME;
DECLARE   @V_CDOPERADOR VARCHAR(12);
DECLARE   @V_IDUTRPADCA VARCHAR(1);
DECLARE   @V_CONTPRODRECE DOUBLE PRECISION;
DECLARE   @V_TIPORECE VARCHAR(1);
DECLARE   @V_CDNVPRODUTO VARCHAR(1);
DECLARE   @V_PRODINATIVO INT;
DECLARE   @V_CDCARD VARCHAR(10);
DECLARE   @V_COUNT NUMERIC;
DECLARE   @V_DTLIBECARDMATR DATETIME;
DECLARE   @V_IDCARDDESCENTR VARCHAR(1);
DECLARE   @V_NRSEQLOG DOUBLE PRECISION;
DECLARE   @V_CDCARDCICLO VARCHAR(05);
DECLARE   @V_NRCICLO VARCHAR(3);
DECLARE   @V_MAXDATA DATETIME;
DECLARE   @V_VRPECONSCARD FLOAT;
DECLARE   @V_CDPRATO VARCHAR(10);

   /* VARIAVEIS - TABELA DE SERVICO */
DECLARE   @V_QTCOMESTISEG DOUBLE PRECISION;
DECLARE   @V_QTCOMESTITER DOUBLE PRECISION;
DECLARE   @V_QTCOMESTIQUA DOUBLE PRECISION;
DECLARE   @V_QTCOMESTIQUI DOUBLE PRECISION;
DECLARE   @V_QTCOMESTISEX DOUBLE PRECISION;
DECLARE   @V_QTCOMESTISAB DOUBLE PRECISION;
DECLARE   @V_QTCOMESTIDOM DOUBLE PRECISION;
DECLARE   @V_QTCOMESTIFER DOUBLE PRECISION;
DECLARE   @V_QTCLIESTISEG DOUBLE PRECISION;
DECLARE   @V_QTCLIESTITER DOUBLE PRECISION;
DECLARE   @V_QTCLIESTIQUA DOUBLE PRECISION;
DECLARE   @V_QTCLIESTIQUI DOUBLE PRECISION;
DECLARE   @V_QTCLIESTISEX DOUBLE PRECISION;
DECLARE   @V_QTCLIESTISAB DOUBLE PRECISION;
DECLARE   @V_QTCLIESTIDOM DOUBLE PRECISION;
DECLARE   @V_QTCLIESTIFER DOUBLE PRECISION;
DECLARE   @V_QTFUNESTISEG DOUBLE PRECISION;
DECLARE   @V_QTFUNESTITER DOUBLE PRECISION;
DECLARE   @V_QTFUNESTIQUA DOUBLE PRECISION;
DECLARE   @V_QTFUNESTIQUI DOUBLE PRECISION;
DECLARE   @V_QTFUNESTISEX DOUBLE PRECISION;
DECLARE   @V_QTFUNESTISAB DOUBLE PRECISION;
DECLARE   @V_QTFUNESTIDOM DOUBLE PRECISION;
DECLARE   @V_QTFUNESTIFER DOUBLE PRECISION;
DECLARE   @V_QTDOAESTISEG DOUBLE PRECISION;
DECLARE   @V_QTDOAESTITER DOUBLE PRECISION;
DECLARE   @V_QTDOAESTIQUA DOUBLE PRECISION;
DECLARE   @V_QTDOAESTIQUI DOUBLE PRECISION;
DECLARE   @V_QTDOAESTISEX DOUBLE PRECISION;
DECLARE   @V_QTDOAESTISAB DOUBLE PRECISION;
DECLARE   @V_QTDOAESTIDOM DOUBLE PRECISION;
DECLARE   @V_QTDOAESTIFER DOUBLE PRECISION;
DECLARE   @V_QTESTITURNO1 DOUBLE PRECISION;
DECLARE   @V_QTESTITURNO2 DOUBLE PRECISION;
DECLARE   @V_QTESTITURNO3 DOUBLE PRECISION;
DECLARE   @V_QTESTITURNO4 DOUBLE PRECISION;

DECLARE   @V_QTCOMESTICAR DOUBLE PRECISION;
DECLARE   @V_QTCLIESTICAR DOUBLE PRECISION;
DECLARE   @V_QTFUNESTICAR DOUBLE PRECISION;
DECLARE   @V_QTDOAESTICAR DOUBLE PRECISION;

DECLARE   @V_DTFERIFILI DATETIME; /* DATA FERIADO */

DECLARE   @V_INCTURNO     NUMERIC;

DECLARE   @V_CDCENTRAL VARCHAR(4);

DECLARE   @V_IDUTCARDPADR VARCHAR(1);
DECLARE   @V_IDCARDIAUTIL VARCHAR(1);
DECLARE   @V_SEQ VARCHAR(12);

/*CURSORES*/
DECLARE @C_DATA_DTDATA DATETIME;
DECLARE @C_TURNO_QTCOMESTTDOM FLOAT;
DECLARE @C_TURNO_QTCOMESTTSEG FLOAT;
DECLARE @C_TURNO_QTCOMESTTTER FLOAT;
DECLARE @C_TURNO_QTCOMESTTQUA FLOAT;
DECLARE @C_TURNO_QTCOMESTTQUI FLOAT;
DECLARE @C_TURNO_QTCOMESTTSEX FLOAT;
DECLARE @C_TURNO_QTCOMESTTSAB FLOAT;
DECLARE @C_TURNO_QTCOMESTTFER FLOAT;

DECLARE @C_COMPCARD_NRSEQCARDCICLO SMALLINT;
DECLARE @C_COMPCARD_CDFILAUXPRAT VARCHAR(4);
DECLARE @C_COMPCARD_CDPRATO VARCHAR(10);
DECLARE @C_COMPCARD_CDTIPOPRAT VARCHAR(2);
DECLARE @C_COMPCARD_NRORDCNFCICLO SMALLINT;
DECLARE @C_COMPCARD_VRPECONSCARDCICLO FLOAT;

DECLARE @C_RECESERV_CDPRODUTO VARCHAR(10);
DECLARE @C_RECESERV_IDPRODATIVPR VARCHAR(1);
DECLARE @C_RECESERV_IDPRODATIV VARCHAR(1);
DECLARE @C_RECEFILI_CDPRODUTO VARCHAR(10);
DECLARE @C_RECEFILI_IDPRODATIVPR VARCHAR(1);
DECLARE @C_RECEFILI_IDPRODATIV VARCHAR(1);
DECLARE @C_RECEPADR_CDPRODUTO VARCHAR(10);
DECLARE @C_RECEPADR_IDPRODATIVPR VARCHAR(1);
DECLARE @C_RECEPADR_IDPRODATIV VARCHAR(1);

BEGIN
   SELECT @V_IDUTCARDPADR = MAX(IDUTCARDPADR),@V_IDUTRPADCA = MAX(IDUTRPADCA)
   FROM PARAMGERAL;
   IF (@V_IDUTCARDPADR = 'S') BEGIN

      SELECT @V_CDCENTRAL = MAX(CDFILCENTPME)
      FROM FILIAL
      WHERE CDFILIAL = @P_CDFILIAL;

      IF (@V_CDCENTRAL IS NOT NULL) BEGIN
         RETURN;
      END;
   END;

   IF (@V_IDUTCARDPADR = 'D') BEGIN
      SELECT @V_CDGRUPOPER = MAX(CDGRUPOPER)
      FROM AUTGRUPOP
      WHERE IDAUTGRUPOP = 'LRCD';

      IF @V_CDGRUPOPER IS NOT NULL BEGIN
         SELECT @V_CDOPERADOR = MAX(CDOPERADOR)
         FROM OPERGRUPOP
         WHERE CDGRUPOPER = @V_CDGRUPOPER
           AND CDOPERADOR = @P_CDOPERADOR;

         IF @V_CDOPERADOR IS NULL BEGIN
            RETURN;
         END;
      END;

      SELECT @V_IDCARDDESCENTR = ISNULL(MAX(IDCARDDESCENTR), 'N')
      FROM SERVICO
      WHERE CDFILIAL = @P_CDFILIAL
        AND CDSERVFILI = @P_CDSERVFILI
        AND IDTIPOSERV = 'N';

      IF @V_IDCARDDESCENTR <> 'N' BEGIN
         SELECT @V_DTLIBECARDMATR = MAX(DTLIBECARDMATR)
         FROM CTRLAPROVCARD
         WHERE CDFILIAL = @P_CDFILIAL
           AND CDSERVFILI = @P_CDSERVFILI
           AND DTMESCARDAPROV = @P_DTMESCARD;
         IF @V_DTLIBECARDMATR IS NOT NULL BEGIN
            RETURN;
         END;
      END;
   END;

   SELECT @V_CDCARD = MAX(CDCARDCICLO)
   FROM CARDCICLO
   WHERE CDCARDCICLO = SUBSTRING(TEKNISA.RETORNA_NRCICLO(@P_CDFILIAL, @P_CDSERVFILI, @P_DTMESCARD), 1, 5)
     AND IDATIVCICLO = 'S';

   IF @V_CDCARD IS NULL BEGIN
      RETURN;
   END;

   SELECT @V_COUNT = COUNT(1)
   FROM COMPCARDCICLO CP, CNFCARDCICLO CF
   WHERE CP.CDCARDCICLO = @V_CDCARD
     AND CP.CDPADCICLO = @P_CDPADCICLO
     AND CF.CDCARDCICLO = CP.CDCARDCICLO
     AND CF.CDPADCICLO = CP.CDPADCICLO
     AND CF.NRSEQCNFCICLO = CP.NRSEQCARDCICLO;

   IF NOT (@V_COUNT > 0) BEGIN
      RETURN;
   END;

   IF @P_IDEXCLUIRCARD = 'S' BEGIN
      IF (@P_DTMESCARD > GETDATE()) BEGIN
         DELETE FROM COMPCARD
         WHERE CDFILIAL = @P_CDFILIAL
           AND NRCARDAPIO IN (SELECT NRCARDAPIO
                              FROM CARDADIA
                              WHERE CDFILIAL = @P_CDFILIAL
                                AND CDSERVFILI = @P_CDSERVFILI
                                AND DTMESCARD = @P_DTMESCARD);

         DELETE FROM CARDADIA
         WHERE CDFILIAL = @P_CDFILIAL
         AND CDSERVFILI = @P_CDSERVFILI
         AND DTMESCARD = @P_DTMESCARD;

         DELETE FROM CARDAMES
         WHERE CDFILIAL = @P_CDFILIAL
           AND CDSERVFILI = @P_CDSERVFILI
           AND DTMESCARDAPIO = @P_DTMESCARD;
      END;
   END;

   SELECT @V_DTMESCARDAPIO = MAX(DTMESCARDAPIO)
   FROM CARDAMES
   WHERE CDFILIAL = @P_CDFILIAL
     AND CDSERVFILI = @P_CDSERVFILI
     AND DTMESCARDAPIO = @P_DTMESCARD;

   IF @V_DTMESCARDAPIO IS NULL BEGIN
      DELETE FROM CNFCAMES
      WHERE CDFILIAL     = @P_CDFILIAL AND
            CDSERVFILI   = @P_CDSERVFILI AND
            DTREFECNFMES = @P_DTMESCARD;

      INSERT INTO CNFCAMES
         (CDFILIAL, CDSERVFILI, NRSEQCNFMES, DTREFECNFMES,
          CDTIPOPRAT, IDOPCCNFMES, NRORDCNFMES, DSCOMPLTPMES,
          IDIMPCNFMES)
      SELECT @P_CDFILIAL, @P_CDSERVFILI, NRSEQCNFCICLO, @P_DTMESCARD,
             CDTIPOPRAT, IDOPCARDCICLO, NRORDCNFCICLO, DSCOMPTPCICLO,
             'S'
      FROM CNFCARDCICLO
      WHERE CDCARDCICLO = SUBSTRING(TEKNISA.RETORNA_NRCICLO(@P_CDFILIAL, @P_CDSERVFILI, @P_DTMESCARD), 1, 5)
        AND CDPADCICLO = @P_CDPADCICLO;

      INSERT INTO CARDAMES (CDFILIAL, CDSERVFILI, DTMESCARDAPIO, IDCARDCICLO, CDCARDCICLO)
      VALUES (@P_CDFILIAL, @P_CDSERVFILI, @P_DTMESCARD, 'S', @V_CDCARD);

      SET @V_NRSEQLOG = 0;

      DECLARE C_DATA CURSOR FOR
         SELECT DTDATA
         FROM DATA
         WHERE DTMES = @P_DTMESCARD
         ORDER BY DTDATA
      OPEN C_DATA;
      FETCH NEXT FROM C_DATA INTO @C_DATA_DTDATA;
      WHILE(@@FETCH_STATUS = 0) BEGIN

         SELECT @V_DTFERIFILI = MAX(DTFERIFILI)
         FROM FERIFILI
         WHERE (CDFILIAL   = @P_CDFILIAL) AND
               (DTFERIFILI = @C_DATA_DTDATA);

         SELECT @V_IDCARDIAUTIL = MAX(IDCARDIAUTIL)
         FROM PARAMPLANEJA
         WHERE (CDFILIAL = @P_CDFILIAL);

         IF NOT ((@V_DTFERIFILI IS NOT NULL) AND (@V_IDCARDIAUTIL = 'S')) BEGIN

            ----------------------SOLICITAO 124881 ------------------------

            /*RETORNA NRO DO CICLO REFERENTE A DATA DO CARDAPIO*/
            SELECT @V_CDCARDCICLO = SUBSTRING(CI.NRCICLO,1,5), @V_NRCICLO = SUBSTRING(CI.NRCICLO, 6, 3)
              FROM (SELECT TEKNISA.RETORNA_NRCICLO(@P_CDFILIAL, @P_CDSERVFILI, @C_DATA_DTDATA) AS NRCICLO ) CI

            /*RETORNA A ULTIMA DATA EM QUE O CICLO RODOU EM ALGUM MES ANTERIOR*/
            /*SELECT @V_MAXDATA = MAX(DTDATA)
              FROM DATA DT
              WHERE (SUBSTRING((SELECT TEKNISA.RETORNA_NRCICLO(@P_CDFILIAL, @P_CDSERVFILI, DT.DTDATA) AS NRCICLO), 6, 3) = @V_NRCICLO)
                AND (SUBSTRING((SELECT TEKNISA.RETORNA_NRCICLO(@P_CDFILIAL, @P_CDSERVFILI, DT.DTDATA) AS NRCICLO), 1, 5) = @V_CDCARDCICLO)
                AND (DT.DTDATA < (SELECT MAX(DTDATA)
                                    FROM DATA D
                                    WHERE (SUBSTRING((SELECT TEKNISA.RETORNA_NRCICLO(@P_CDFILIAL, @P_CDSERVFILI, D.DTDATA) AS NRCICLO), 6, 3) = '1')
                                      AND (SUBSTRING((SELECT TEKNISA.RETORNA_NRCICLO(@P_CDFILIAL, @P_CDSERVFILI, D.DTDATA) AS NRCICLO), 1, 5) = @V_CDCARDCICLO)
                                      AND (D.DTDATA < @P_DTMESCARD)));*/


            SELECT @V_QTCOMESTISEG = ISNULL(SUM(QTCOMESTISEG), 0), @V_QTCOMESTITER = ISNULL(SUM(QTCOMESTITER), 0),
                   @V_QTCOMESTIQUA = ISNULL(SUM(QTCOMESTIQUA), 0), @V_QTCOMESTIQUI = ISNULL(SUM(QTCOMESTIQUI), 0), @V_QTCOMESTISEX = ISNULL(SUM(QTCOMESTISEX), 0),
                   @V_QTCOMESTISAB = ISNULL(SUM(QTCOMESTISAB), 0), @V_QTCOMESTIDOM = ISNULL(SUM(QTCOMESTIDOM), 0), @V_QTCOMESTIFER = ISNULL(SUM(QTCOMESTIFER), 0),
                   @V_QTCLIESTISEG = ISNULL(SUM(QTCLIESTISEG), 0), @V_QTCLIESTITER = ISNULL(SUM(QTCLIESTITER), 0), @V_QTCLIESTIQUA = ISNULL(SUM(QTCLIESTIQUA), 0),
                   @V_QTCLIESTIQUI = ISNULL(SUM(QTCLIESTIQUI), 0), @V_QTCLIESTISEX = ISNULL(SUM(QTCLIESTISEX), 0), @V_QTCLIESTISAB = ISNULL(SUM(QTCLIESTISAB), 0),
                   @V_QTCLIESTIDOM = ISNULL(SUM(QTCLIESTIDOM), 0), @V_QTCLIESTIFER = ISNULL(SUM(QTCLIESTIFER), 0), @V_QTFUNESTISEG = ISNULL(SUM(QTFUNESTISEG), 0),
                   @V_QTFUNESTITER = ISNULL(SUM(QTFUNESTITER), 0), @V_QTFUNESTIQUA = ISNULL(SUM(QTFUNESTIQUA), 0), @V_QTFUNESTIQUI = ISNULL(SUM(QTFUNESTIQUI), 0),
                   @V_QTFUNESTISEX = ISNULL(SUM(QTFUNESTISEX), 0), @V_QTFUNESTISAB = ISNULL(SUM(QTFUNESTISAB), 0), @V_QTFUNESTIDOM = ISNULL(SUM(QTFUNESTIDOM), 0),
                   @V_QTFUNESTIFER = ISNULL(SUM(QTFUNESTIFER), 0), @V_QTDOAESTISEG = ISNULL(SUM(QTDOAESTISEG), 0), @V_QTDOAESTITER = ISNULL(SUM(QTDOAESTITER), 0),
                   @V_QTDOAESTIQUA = ISNULL(SUM(QTDOAESTIQUA), 0), @V_QTDOAESTIQUI = ISNULL(SUM(QTDOAESTIQUI), 0), @V_QTDOAESTISEX = ISNULL(SUM(QTDOAESTISEX), 0),
                   @V_QTDOAESTISAB = ISNULL(SUM(QTDOAESTISAB), 0), @V_QTDOAESTIDOM = ISNULL(SUM(QTDOAESTIDOM), 0), @V_QTDOAESTIFER = ISNULL(SUM(QTDOAESTIFER), 0)
            FROM SERVICO
            WHERE CDFILIAL = @P_CDFILIAL
              AND CDSERVFILI = @P_CDSERVFILI
            GROUP BY CDFILIAL, CDSERVFILI;

            IF (@V_DTFERIFILI IS NULL) BEGIN
               SELECT @V_DTFERIFILI = MAX(DTFERICARD)
               FROM FERICARD
               WHERE CDFILIAL = @P_CDFILIAL
                 AND DTFERICARD = @C_DATA_DTDATA;
            END;

            IF (@V_DTFERIFILI IS NOT NULL) BEGIN
                /* Grava comensais para Feriado */
               SET @V_QTCOMESTICAR = @V_QTCOMESTIFER;
               SET @V_QTCLIESTICAR = @V_QTCLIESTIFER;
               SET @V_QTFUNESTICAR = @V_QTFUNESTIFER;
               SET @V_QTDOAESTICAR = @V_QTDOAESTIFER;
	    END
            ELSE BEGIN
               /* Grava comensais para os dias da semana (no-feriados) */
               IF DATEPART(W,@C_DATA_DTDATA) = '1' BEGIN
                  SET @V_QTCOMESTICAR = @V_QTCOMESTIDOM;
                  SET @V_QTCLIESTICAR = @V_QTCLIESTIDOM;
                  SET @V_QTFUNESTICAR = @V_QTFUNESTIDOM;
                  SET @V_QTDOAESTICAR = @V_QTDOAESTIDOM;
               END;
               IF DATEPART(W,@C_DATA_DTDATA) = '2' BEGIN
                  SET @V_QTCOMESTICAR = @V_QTCOMESTISEG;
                  SET @V_QTCLIESTICAR = @V_QTCLIESTISEG;
                  SET @V_QTFUNESTICAR = @V_QTFUNESTISEG;
                  SET @V_QTDOAESTICAR = @V_QTDOAESTISEG;
               END;
               IF DATEPART(W,@C_DATA_DTDATA) = '3' BEGIN
                  SET @V_QTCOMESTICAR = @V_QTCOMESTITER;
                  SET @V_QTCLIESTICAR = @V_QTCLIESTITER;
                  SET @V_QTFUNESTICAR = @V_QTFUNESTITER;
                  SET @V_QTDOAESTICAR = @V_QTDOAESTITER;
               END;
               IF DATEPART(W,@C_DATA_DTDATA) = '4' BEGIN
                  SET @V_QTCOMESTICAR = @V_QTCOMESTIQUA;
                  SET @V_QTCLIESTICAR = @V_QTCLIESTIQUA;
                  SET @V_QTFUNESTICAR = @V_QTFUNESTIQUA;
                  SET @V_QTDOAESTICAR = @V_QTDOAESTIQUA;
               END;
               IF DATEPART(W,@C_DATA_DTDATA) = '5' BEGIN
                  SET @V_QTCOMESTICAR = @V_QTCOMESTIQUI;
                  SET @V_QTCLIESTICAR = @V_QTCLIESTIQUI;
                  SET @V_QTFUNESTICAR = @V_QTFUNESTIQUI;
                  SET @V_QTDOAESTICAR = @V_QTDOAESTIQUI;
               END;
               IF DATEPART(W,@C_DATA_DTDATA) = '6' BEGIN
                  SET @V_QTCOMESTICAR = @V_QTCOMESTISEX;
                  SET @V_QTCLIESTICAR = @V_QTCLIESTISEX;
                  SET @V_QTFUNESTICAR = @V_QTFUNESTISEX;
                  SET @V_QTDOAESTICAR = @V_QTDOAESTISEX;
               END;
               IF DATEPART(W,@C_DATA_DTDATA) = '7' BEGIN
                  SET @V_QTCOMESTICAR = @V_QTCOMESTISAB;
                  SET @V_QTCLIESTICAR = @V_QTCLIESTISAB;
                  SET @V_QTFUNESTICAR = @V_QTFUNESTISAB;
                  SET @V_QTDOAESTICAR = @V_QTDOAESTISAB;
               END;
            END;

            SET @V_INCTURNO = 1;
            DECLARE C_TURNO CURSOR FOR
               SELECT QTCOMESTTDOM, QTCOMESTTSEG, QTCOMESTTTER,
                      QTCOMESTTQUA, QTCOMESTTQUI, QTCOMESTTSEX,
                      QTCOMESTTSAB, QTCOMESTTFER
               FROM TURNOSERV
               WHERE CDFILIAL = @P_CDFILIAL
                 AND CDSERVFILI = @P_CDSERVFILI
               ORDER BY CDTURNO
            OPEN C_TURNO;
            FETCH NEXT FROM C_TURNO INTO @C_TURNO_QTCOMESTTDOM, @C_TURNO_QTCOMESTTSEG, @C_TURNO_QTCOMESTTTER,
                                         @C_TURNO_QTCOMESTTQUA, @C_TURNO_QTCOMESTTQUI, @C_TURNO_QTCOMESTTSEX,
                                         @C_TURNO_QTCOMESTTSAB, @C_TURNO_QTCOMESTTFER;
            WHILE (@@FETCH_STATUS = 0) BEGIN

               IF DATEPART(W,@C_DATA_DTDATA) = '1' BEGIN
                  IF @V_INCTURNO = 1 BEGIN
                     SET @V_QTESTITURNO1 = @C_TURNO_QTCOMESTTDOM;
                  END;
                  IF @V_INCTURNO = 2 BEGIN
                     SET @V_QTESTITURNO2 = @C_TURNO_QTCOMESTTDOM;
                  END;
                  IF @V_INCTURNO = 3 BEGIN
                     SET @V_QTESTITURNO3 = @C_TURNO_QTCOMESTTDOM;
                  END;
                  IF @V_INCTURNO = 4 BEGIN
                     SET @V_QTESTITURNO4 = @C_TURNO_QTCOMESTTDOM;
                  END;
               END;
               IF DATEPART(W,@C_DATA_DTDATA) = '2' BEGIN
                  IF @V_INCTURNO = 1 BEGIN
                     SET @V_QTESTITURNO1 = @C_TURNO_QTCOMESTTSEG;
                  END;
                  IF @V_INCTURNO = 2 BEGIN
                     SET @V_QTESTITURNO2 = @C_TURNO_QTCOMESTTSEG;
                  END;
                  IF @V_INCTURNO = 3 BEGIN
                     SET @V_QTESTITURNO3 = @C_TURNO_QTCOMESTTSEG;
                  END;
                  IF @V_INCTURNO = 4 BEGIN
                     SET @V_QTESTITURNO4 = @C_TURNO_QTCOMESTTSEG;
                  END;
               END;
               IF DATEPART(W,@C_DATA_DTDATA) = '3' BEGIN
                  IF @V_INCTURNO = 1 BEGIN
                     SET @V_QTESTITURNO1 = @C_TURNO_QTCOMESTTTER;
                  END;
                  IF @V_INCTURNO = 2 BEGIN
                     SET @V_QTESTITURNO2 = @C_TURNO_QTCOMESTTTER;
                  END;
                  IF @V_INCTURNO = 3 BEGIN
                     SET @V_QTESTITURNO3 = @C_TURNO_QTCOMESTTTER;
                  END;
                  IF @V_INCTURNO = 4 BEGIN
                     SET @V_QTESTITURNO4 = @C_TURNO_QTCOMESTTTER;
                  END;
               END;
               IF DATEPART(W,@C_DATA_DTDATA) = '4' BEGIN
                  IF @V_INCTURNO = 1 BEGIN
                     SET @V_QTESTITURNO1 = @C_TURNO_QTCOMESTTQUA;
                  END;
                  IF @V_INCTURNO = 2 BEGIN
                     SET @V_QTESTITURNO2 = @C_TURNO_QTCOMESTTQUA;
                  END;
                  IF @V_INCTURNO = 3 BEGIN
                     SET @V_QTESTITURNO3 = @C_TURNO_QTCOMESTTQUA;
                  END;
                  IF @V_INCTURNO = 4 BEGIN
                     SET @V_QTESTITURNO4 = @C_TURNO_QTCOMESTTQUA;
                  END;
               END;
               IF DATEPART(W,@C_DATA_DTDATA) = '5' BEGIN
                  IF @V_INCTURNO = 1 BEGIN
                     SET @V_QTESTITURNO1 = @C_TURNO_QTCOMESTTQUI;
                  END;
                  IF @V_INCTURNO = 2 BEGIN
                     SET @V_QTESTITURNO2 = @C_TURNO_QTCOMESTTQUI;
                  END;
                  IF @V_INCTURNO = 3 BEGIN
                     SET @V_QTESTITURNO3 = @C_TURNO_QTCOMESTTQUI;
                  END;
                  IF @V_INCTURNO = 4 BEGIN
                     SET @V_QTESTITURNO4 = @C_TURNO_QTCOMESTTQUI;
                  END;
               END;
               IF DATEPART(W,@C_DATA_DTDATA) = '6' BEGIN
                  IF @V_INCTURNO = 1 BEGIN
                     SET @V_QTESTITURNO1 = @C_TURNO_QTCOMESTTSEX;
                  END;
                  IF @V_INCTURNO = 2 BEGIN
                     SET @V_QTESTITURNO2 = @C_TURNO_QTCOMESTTSEX;
                  END;
                  IF @V_INCTURNO = 3 BEGIN
                     SET @V_QTESTITURNO3 = @C_TURNO_QTCOMESTTSEX;
                  END;
                  IF @V_INCTURNO = 4 BEGIN
                     SET @V_QTESTITURNO4 = @C_TURNO_QTCOMESTTSEX;
                  END;
               END;
               IF DATEPART(W,@C_DATA_DTDATA) = '7' BEGIN
                  IF @V_INCTURNO = 1 BEGIN
                     SET @V_QTESTITURNO1 = @C_TURNO_QTCOMESTTSAB;
                  END;
                  IF @V_INCTURNO = 2 BEGIN
                     SET @V_QTESTITURNO2 = @C_TURNO_QTCOMESTTSAB;
                  END;
                  IF @V_INCTURNO = 3 BEGIN
                     SET @V_QTESTITURNO3 = @C_TURNO_QTCOMESTTSAB;
                  END;
                  IF @V_INCTURNO = 4 BEGIN
                     SET @V_QTESTITURNO4 = @C_TURNO_QTCOMESTTSAB;
                  END;
               END;

               IF (@V_DTFERIFILI IS NOT NULL) BEGIN
                  IF @V_INCTURNO = 1 BEGIN
                     SET @V_QTESTITURNO1 = @C_TURNO_QTCOMESTTFER;
                  END;
                  IF @V_INCTURNO = 2 BEGIN
                     SET @V_QTESTITURNO2 = @C_TURNO_QTCOMESTTFER;
                  END;
                  IF @V_INCTURNO = 3 BEGIN
                     SET @V_QTESTITURNO3 = @C_TURNO_QTCOMESTTFER;
                  END;
                  IF @V_INCTURNO = 4 BEGIN
                     SET @V_QTESTITURNO4 = @C_TURNO_QTCOMESTTFER;
                  END;
               END;

               SET @V_INCTURNO = @V_INCTURNO + 1;
               FETCH NEXT FROM C_TURNO INTO @C_TURNO_QTCOMESTTDOM, @C_TURNO_QTCOMESTTSEG, @C_TURNO_QTCOMESTTTER,
                                            @C_TURNO_QTCOMESTTQUA, @C_TURNO_QTCOMESTTQUI, @C_TURNO_QTCOMESTTSEX,
                                            @C_TURNO_QTCOMESTTSAB, @C_TURNO_QTCOMESTTFER;
            END;
            CLOSE C_TURNO;
            DEALLOCATE C_TURNO;

            IF (@V_QTCOMESTICAR > 0) BEGIN
               SET @V_NRCARDAPIO = NULL;
               DECLARE C_COMPCARD CURSOR FOR
                  SELECT CP.NRSEQCARDCICLO, CP.CDFILAUXPRAT, CP.CDPRATO,
                         CP.CDTIPOPRAT, CF.NRORDCNFCICLO, CP.VRPECONSCARDCICLO
                  FROM COMPCARDCICLO CP, CNFCARDCICLO CF,
                      (SELECT TEKNISA.RETORNA_NRCICLO(@P_CDFILIAL, @P_CDSERVFILI, @C_DATA_DTDATA) AS NRCICLO ) CI
                  WHERE CP.CDCARDCICLO = SUBSTRING(CI.NRCICLO, 1, 5)
                    AND CP.NRCARDCICLO = SUBSTRING(CI.NRCICLO, 6, 3)
                    AND CP.CDPADCICLO  = @P_CDPADCICLO
                    AND CF.CDCARDCICLO = CP.CDCARDCICLO
                    AND CF.CDPADCICLO = CP.CDPADCICLO
                    AND CF.NRSEQCNFCICLO = CP.NRSEQCARDCICLO
               OPEN C_COMPCARD;
               FETCH NEXT FROM C_COMPCARD INTO @C_COMPCARD_NRSEQCARDCICLO,@C_COMPCARD_CDFILAUXPRAT,
                                               @C_COMPCARD_CDPRATO,@C_COMPCARD_CDTIPOPRAT,@C_COMPCARD_NRORDCNFCICLO, @C_COMPCARD_VRPECONSCARDCICLO;
               WHILE(@@FETCH_STATUS = 0)BEGIN
                  /* IDUTRPADCA = 'N' --> NO PERMITE RECEITA PADRO NO CARDPIO */
                  SET @V_CONTPRODRECE = 0;
                  IF @V_IDUTRPADCA = 'N' BEGIN
                     SELECT @V_CONTPRODRECE = SUM(NUM)
                     FROM (SELECT COUNT(1) NUM
                           FROM RECEFILI
                           WHERE CDFILAUXPRAT = @C_COMPCARD_CDFILAUXPRAT
                             AND CDPRATO = @C_COMPCARD_CDPRATO
                             AND CDFILIAL = @P_CDFILIAL
                           UNION ALL
                           SELECT COUNT(1) NUM
                           FROM RECESERV
                           WHERE CDFILAUXPRAT = @C_COMPCARD_CDFILAUXPRAT
                             AND CDPRATO = @C_COMPCARD_CDPRATO
                             AND CDFILIAL = @P_CDFILIAL
                             AND CDSERVFILI = @P_CDSERVFILI) A;
                  END
                  ELSE BEGIN
                     SELECT @V_CONTPRODRECE = SUM(NUM)
                     FROM (SELECT COUNT(1) NUM
                           FROM RECEPADR
                           WHERE CDFILAUXPRAT = @C_COMPCARD_CDFILAUXPRAT
                             AND CDPRATO = @C_COMPCARD_CDPRATO
                           UNION ALL
                           SELECT COUNT(1) NUM
                           FROM RECEFILI
                           WHERE CDFILAUXPRAT = @C_COMPCARD_CDFILAUXPRAT
                             AND CDPRATO = @C_COMPCARD_CDPRATO
                             AND CDFILIAL = @P_CDFILIAL
                           UNION ALL
                           SELECT COUNT(1) NUM
                           FROM RECESERV
                           WHERE CDFILAUXPRAT = @C_COMPCARD_CDFILAUXPRAT
                             AND CDPRATO = @C_COMPCARD_CDPRATO
                             AND CDFILIAL = @P_CDFILIAL
                             AND CDSERVFILI = @P_CDSERVFILI) A;
                  END;

                  /* VERIFICAR SE H PRODUTO INATIVO NO PRATO */
                  /* verificar a receita utilizada pelo prato destino */
                  SET @V_TIPORECE = 'N';
                  SELECT @V_TIPORECE = ISNULL(MAX(TIPO), 'N')
                  FROM (SELECT 'S' AS TIPO
                        FROM RECESERV
                        WHERE CDFILIAL = @P_CDFILIAL
                          AND CDSERVFILI = @P_CDSERVFILI
                          AND CDPRATO = @C_COMPCARD_CDPRATO
                          AND CDFILAUXPRAT = @C_COMPCARD_CDFILAUXPRAT
                        UNION ALL
                        SELECT 'F' AS TIPO
                        FROM RECEFILI F
                        WHERE CDFILIAL = @P_CDFILIAL
                          AND CDPRATO = @C_COMPCARD_CDPRATO
                          AND CDFILAUXPRAT = @C_COMPCARD_CDFILAUXPRAT
                          AND NOT EXISTS (SELECT CDPRATO
                                          FROM RECESERV
                                          WHERE CDFILIAL = F.CDFILIAL
                                            AND CDSERVFILI = @P_CDSERVFILI
                                            AND CDPRATO = F.CDPRATO
                                            AND CDFILAUXPRAT = F.CDFILAUXPRAT)
                        UNION ALL
                        SELECT 'P' AS TIPO
                        FROM RECEPADR P
                        WHERE CDPRATO = @C_COMPCARD_CDPRATO
                          AND CDFILAUXPRAT = @P_CDFILIAL
                          AND NOT EXISTS(SELECT CDPRATO
                                         FROM RECEFILI
                                         WHERE CDFILIAL = @P_CDFILIAL
                                           AND CDPRATO = P.CDPRATO
                                           AND CDFILAUXPRAT = P.CDFILAUXPRAT)
                          AND NOT EXISTS (SELECT CDPRATO
                                          FROM RECESERV
                                          WHERE CDFILIAL = @P_CDFILIAL
                                            AND CDSERVFILI = @P_CDSERVFILI
                                            AND CDPRATO = P.CDPRATO
                                            AND CDFILAUXPRAT = P.CDFILAUXPRAT)) A;
                  /************************/
                  /*Parametro para selecionar apenas produto de nvel completo*/
                  SELECT @V_CDNVPRODUTO = MAX(CDNVPRODUTO)
                  FROM PRODUTO;

                  SET @V_PRODINATIVO = 0;

                  IF (@V_TIPORECE = 'S') BEGIN  /*RECEITA POR SERVIO COM PRODUTO INATIVO*/
                     DECLARE C_RECESERV CURSOR FOR
                        SELECT P.CDPRODUTO, P.IDPRODATIVPR, ISNULL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                        FROM PRODUTO P LEFT JOIN PRODFILI PF ON ((PF.CDPRODUTO = P.CDPRODUTO) AND (PF.CDFILIAL = @P_CDFILIAL)), RECESERV RS
                        WHERE
                              P.CDNVPRODUTO = @V_CDNVPRODUTO
                          AND RS.CDFILIAL = @P_CDFILIAL
                          AND RS.CDSERVFILI = @P_CDSERVFILI
                          AND RS.CDPRATO = @C_COMPCARD_CDPRATO
                          AND RS.CDFILAUXPRAT = @C_COMPCARD_CDFILAUXPRAT
                          AND P.CDPRODUTO = RS.CDPRODUTO
                        OPEN C_RECESERV;
                        FETCH NEXT FROM C_RECESERV INTO @C_RECESERV_CDPRODUTO, @C_RECESERV_IDPRODATIVPR, @C_RECESERV_IDPRODATIV;
                        WHILE(@@FETCH_STATUS = 0) BEGIN
                           IF (@C_RECESERV_IDPRODATIV = 'I') OR (@C_RECESERV_IDPRODATIVPR = 'N') BEGIN     /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                              SET @V_PRODINATIVO = 1;
                              SET @V_NRSEQLOG = @V_NRSEQLOG+1;
                              INSERT INTO LOGCARDCICLO(NRLOGCARDCICLO, NRSEQLOGCARD, DTLOGCARDCICLO, IDLOGCARDCICLO, CDFILIAL, CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPRODUTO, CDPADCICLO)
                              VALUES(@P_NRLOGCARDCICLO, @V_NRSEQLOG, @C_DATA_DTDATA, '0', @P_CDFILIAL, @P_CDSERVFILI, @C_COMPCARD_CDPRATO, @C_COMPCARD_CDFILAUXPRAT, @C_RECESERV_CDPRODUTO, @P_CDPADCICLO);
                           END;
                           FETCH NEXT FROM C_RECESERV INTO @C_RECESERV_CDPRODUTO, @C_RECESERV_IDPRODATIVPR, @C_RECESERV_IDPRODATIV;
                        END;
                     CLOSE C_RECESERV;
                     DEALLOCATE C_RECESERV;
                  END
                  ELSE BEGIN
                     IF (@V_TIPORECE = 'F') BEGIN  /*RECEITA LOCAL COM PRODUTO INATIVO*/
                        DECLARE C_RECEFILI CURSOR FOR
                           SELECT P.CDPRODUTO, P.IDPRODATIVPR, ISNULL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                           FROM PRODUTO P LEFT JOIN PRODFILI PF ON ((PF.CDPRODUTO = P.CDPRODUTO)AND(PF.CDFILIAL = @P_CDFILIAL)), RECEFILI RF
                           WHERE
                                 P.CDNVPRODUTO = @V_CDNVPRODUTO
                             AND RF.CDFILIAL = @P_CDFILIAL
                             AND RF.CDPRATO = @C_COMPCARD_CDPRATO
                             AND RF.CDFILAUXPRAT = @C_COMPCARD_CDFILAUXPRAT
                             AND P.CDPRODUTO = RF.CDPRODUTO
                        OPEN C_RECEFILI;
                        FETCH NEXT FROM C_RECEFILI INTO @C_RECEFILI_CDPRODUTO, @C_RECEFILI_IDPRODATIVPR, @C_RECEFILI_IDPRODATIV;
                        WHILE (@@FETCH_STATUS = 0) BEGIN
                           IF (@C_RECEFILI_IDPRODATIV = 'I') OR (@C_RECEFILI_IDPRODATIVPR = 'N') BEGIN     /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                              SET @V_PRODINATIVO = 1;
                              SET @V_NRSEQLOG = @V_NRSEQLOG+1;
                              INSERT INTO LOGCARDCICLO(NRLOGCARDCICLO, NRSEQLOGCARD, DTLOGCARDCICLO, IDLOGCARDCICLO, CDFILIAL, CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPRODUTO, CDPADCICLO)
                              VALUES(@P_NRLOGCARDCICLO, @V_NRSEQLOG, @C_DATA_DTDATA, '0', @P_CDFILIAL, @P_CDSERVFILI, @C_COMPCARD_CDPRATO, @C_COMPCARD_CDFILAUXPRAT, @C_RECEFILI_CDPRODUTO, @P_CDPADCICLO);
                           END;
                           FETCH NEXT FROM C_RECEFILI INTO @C_RECEFILI_CDPRODUTO, @C_RECEFILI_IDPRODATIVPR, @C_RECEFILI_IDPRODATIV;
                        END;
                        CLOSE C_RECEFILI;
                        DEALLOCATE C_RECEFILI;
                     END
                     ELSE BEGIN
                        IF (@V_TIPORECE ='P') BEGIN   /*RECEITA PADRO COM PRODUTO INATIVO*/
                           DECLARE C_RECEPADR CURSOR FOR
                              SELECT P.CDPRODUTO, P.IDPRODATIVPR, ISNULL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                              FROM PRODUTO P LEFT JOIN PRODFILI PF ON ((@P_CDFILIAL = PF.CDFILIAL)AND(P.CDPRODUTO = PF.CDPRODUTO)), RECEPADR RP
                              WHERE P.CDNVPRODUTO = @V_CDNVPRODUTO
                                AND RP.CDPRATO = @C_COMPCARD_CDPRATO
                                AND RP.CDFILAUXPRAT = @C_COMPCARD_CDFILAUXPRAT
                                AND RP.CDPRODUTO = P.CDPRODUTO
                           OPEN C_RECEPADR;
                           FETCH NEXT FROM C_RECEPADR INTO @C_RECEPADR_CDPRODUTO, @C_RECEPADR_IDPRODATIVPR, @C_RECEPADR_IDPRODATIV;
                           WHILE(@@FETCH_STATUS = 0) BEGIN
                              IF (@C_RECEPADR_IDPRODATIV = 'I') OR (@C_RECEPADR_IDPRODATIVPR = 'N') BEGIN /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                                 SET @V_PRODINATIVO = 1;
                                 SET @V_NRSEQLOG = @V_NRSEQLOG+1;
                                 INSERT INTO LOGCARDCICLO(NRLOGCARDCICLO, NRSEQLOGCARD, DTLOGCARDCICLO, IDLOGCARDCICLO, CDFILIAL, CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPRODUTO, CDPADCICLO)
                                 VALUES(@P_NRLOGCARDCICLO, @V_NRSEQLOG, @C_DATA_DTDATA, '0', @P_CDFILIAL, @P_CDSERVFILI, @C_COMPCARD_CDPRATO, @C_COMPCARD_CDFILAUXPRAT, @C_RECEPADR_CDPRODUTO, @P_CDPADCICLO);
                              END;
                              FETCH NEXT FROM C_RECEPADR INTO @C_RECEPADR_CDPRODUTO, @C_RECEPADR_IDPRODATIVPR, @C_RECEPADR_IDPRODATIV;
                           END;
                           CLOSE C_RECEPADR;
                           DEALLOCATE C_RECEPADR;
                        END; /*RECEITA PADRO COM PRODUTO INATIVO*/
                     END;  /*RECEITA LOCAL COM PRODUTO INATIVO */
                  END; /*RECEITA POR SERVIO COM PRODUTO INATIVO */
                          /***********************/
                          /* FIM - VERIFICAR SE H PRODUTO INATIVO NO PRATO */
                  IF @V_CONTPRODRECE = 0 BEGIN
                     SET @V_NRSEQLOG = @V_NRSEQLOG+1;
                     INSERT INTO LOGCARDCICLO(NRLOGCARDCICLO, NRSEQLOGCARD, DTLOGCARDCICLO, IDLOGCARDCICLO, CDFILIAL, CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPADCICLO)
                     VALUES(@P_NRLOGCARDCICLO, @V_NRSEQLOG, @C_DATA_DTDATA, '1', @P_CDFILIAL, @P_CDSERVFILI, @C_COMPCARD_CDPRATO, @C_COMPCARD_CDFILAUXPRAT, @P_CDPADCICLO);
                  END;

                  IF (@V_PRODINATIVO = 0) AND (@V_CONTPRODRECE > 0) BEGIN
                     SELECT @V_NRCARDAPIO = MAX(NRCARDAPIO)                       
                       FROM CARDADIA
                      WHERE CDFILIAL   = @P_CDFILIAL
                        AND CDSERVFILI = @P_CDSERVFILI
                        AND DTCARDAPIO = @C_DATA_DTDATA
                        AND CDDIETPAD IS NULL;				  
				  
                     IF @V_NRCARDAPIO IS NULL BEGIN
						SET @V_SEQ = 'CARDAPIO' + @P_CDFILIAL;
                        EXEC TEKNISA.NOVO_CODIGO_SC @V_SEQ, @P_SEQUENCIAL = @V_NRCARDAPIO OUTPUT, @P_QTDE =1 ;
                        SET @V_NRCARDAPIO = SUBSTRING(@V_NRCARDAPIO, 11, 10);

                        INSERT INTO CARDADIA(CDFILIAL,     NRCARDAPIO,   CDSERVFILI,
                                             CDOPERADOR,   DTCARDAPIO,   DTMESCARD,
                                             QTCOMESTICAR, QTESTITURNO1, QTESTITURNO2,
                                             QTESTITURNO3, QTESTITURNO4, QTCLIESTICAR,
                                             QTFUNESTICAR, QTDOAESTICAR)
                        VALUES(@P_CDFILIAL, SUBSTRING(@V_NRCARDAPIO, 1, 10), @P_CDSERVFILI,
                               @P_CDOPERADOR, @C_DATA_DTDATA, @P_DTMESCARD,
                               @V_QTCOMESTICAR, @V_QTESTITURNO1, @V_QTESTITURNO2,
                               @V_QTESTITURNO3, @V_QTESTITURNO4, @V_QTCLIESTICAR,
                               @V_QTFUNESTICAR, @V_QTDOAESTICAR);
                     END;

                     /*VERIFICA O PERCENTUAL DE APROVEITAMENTO DO PRATO NO CICLO ANTERIOR, SE NO EXISTIR VAI INSERIR 100*/
                     /*SELECT @V_VRPECONSCARD = MAX(CM.VRPECONSCARD), @V_CDPRATO = MAX(CM.CDPRATO)
                       FROM COMPCARD CM, CARDADIA CD 
                      WHERE CM.CDFILIAL = @P_CDFILIAL 
                        AND CM.NRSEQPRATCAR = @C_COMPCARD_NRSEQCARDCICLO
                        AND CM.CDTIPOPRAT = @C_COMPCARD_CDTIPOPRAT
                        AND CM.CDFILIAL = CD.CDFILIAL
                        AND CD.CDSERVFILI  = @P_CDSERVFILI
                        AND CM.NRCARDAPIO = CD.NRCARDAPIO 
                        AND CD.DTCARDAPIO = @V_MAXDATA ;  
  
                     IF (@V_VRPECONSCARD) IS NULL BEGIN
                        SET @V_VRPECONSCARD = 100;
                     END
                     ELSE BEGIN
                        IF @V_CDPRATO <> @C_COMPCARD_CDPRATO BEGIN -- SE PRATOS FOREM DIFERENTES INSERE UMA RESTRICAO NO LOG
                           SET @V_NRSEQLOG = @V_NRSEQLOG+1;
						   INSERT INTO LOGCARDCICLO(NRLOGCARDCICLO, NRSEQLOGCARD, DTLOGCARDCICLO, IDLOGCARDCICLO, CDFILIAL, CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPADCICLO)
						   VALUES(@P_NRLOGCARDCICLO, @V_NRSEQLOG, @C_DATA_DTDATA, '3', @P_CDFILIAL, @P_CDSERVFILI, @C_COMPCARD_CDPRATO, @C_COMPCARD_CDFILAUXPRAT, @P_CDPADCICLO);
                        END;
                     END;*/

                     INSERT INTO COMPCARD(CDFILIAL,     NRCARDAPIO, NRSEQPRATCAR,
                                          CDFILAUXPRAT, CDPRATO,    VRPECONSCARD,
                                          CDTIPOPRAT, NRORDPRATCAR)
                      VALUES(@P_CDFILIAL, @V_NRCARDAPIO, @C_COMPCARD_NRSEQCARDCICLO,
                            @C_COMPCARD_CDFILAUXPRAT, @C_COMPCARD_CDPRATO, @C_COMPCARD_VRPECONSCARDCICLO, /*@V_VRPECONSCARD,*/
                            @C_COMPCARD_CDTIPOPRAT, @C_COMPCARD_NRORDCNFCICLO);

                  END;  
                  FETCH NEXT FROM C_COMPCARD INTO @C_COMPCARD_NRSEQCARDCICLO,@C_COMPCARD_CDFILAUXPRAT,
                                                  @C_COMPCARD_CDPRATO,@C_COMPCARD_CDTIPOPRAT,@C_COMPCARD_NRORDCNFCICLO;
               END;
               CLOSE C_COMPCARD;
               DEALLOCATE C_COMPCARD;
            END
            ELSE BEGIN
               SET @V_NRSEQLOG = @V_NRSEQLOG+1;
               INSERT INTO LOGCARDCICLO(NRLOGCARDCICLO, NRSEQLOGCARD, DTLOGCARDCICLO, IDLOGCARDCICLO, CDFILIAL, CDSERVFILI, CDPRATO, CDFILAUXPRAT,CDPADCICLO)
               VALUES(@P_NRLOGCARDCICLO, @V_NRSEQLOG, @C_DATA_DTDATA, '2', @P_CDFILIAL, @P_CDSERVFILI, NULL, NULL, @P_CDPADCICLO);
            END;
         END;
         FETCH NEXT FROM C_DATA INTO @C_DATA_DTDATA;
      END;
      CLOSE C_DATA;
      DEALLOCATE C_DATA;
   END;
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'CRIACARD_CICLO','5.50.000';
GO